SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'EtchegoyenLajePulver 5/21/2013 00:54'!
canNotConvertMeasurementException
	
	^ UnitTypeMismatchConversionError! !

!MeasureTest methodsFor: 'temperature units' stamp: 'EtchegoyenLajePulver 5/23/2013 20:49'!
celsius
"	^ TemperatureUnit baseUnit"
	"^ TemperatureUnit withUnit: 'celsius' withConversionFactor: 1 "
	^ TemperatureUnit withUnit: 'celsius' withConversionFactor: 1 withConversionOffset: (-27315/100) ! !

!MeasureTest methodsFor: 'distance units' stamp: 'EtchegoyenLajePulver 5/20/2013 21:24'!
centimeter
	
	^ DistanceUnit withUnit: 'centimeter' withConversionFactor: (1/100) ! !

!MeasureTest methodsFor: 'time units' stamp: 'EtchegoyenLajePulver 5/20/2013 23:36'!
day
	
	^ TimeUnit withUnit: 'day' withConversionFactor: 86400! !

!MeasureTest methodsFor: 'distance units' stamp: 'EtchegoyenLajePulver 5/20/2013 21:54'!
decameter
	
	^ DistanceUnit withUnit: 'decameter' withConversionFactor: 10! !

!MeasureTest methodsFor: 'distance units' stamp: 'EtchegoyenLajePulver 5/20/2013 21:39'!
decimeter
	
	^ DistanceUnit withUnit: 'decimeter' withConversionFactor: (1/10)! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 00:26'!
eightCubicMeters

	^CompoundMeasure withAmount: 8 withUnit: (CompoundUnit withUnitsAndPowers: {self meter . 3})! !

!MeasureTest methodsFor: 'temperature units' stamp: 'EtchegoyenLajePulver 5/23/2013 20:47'!
fahrenheit
	
	"^ TemperatureUnit withUnit: 'fahrenheit' withConversionFactor: (5/9) withConversionOffset: 32"
	
	^ TemperatureUnit withUnit: 'fahrenheit' withConversionFactor: (5/9) withConversionOffset: (-45967/100)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 01:21'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^ initialSpeed + (anAcceleration * aTimePeriod )
	"self error: 'Implementar la formula de velocidad final: vf = vi + a * t'"! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 00:25'!
fourSquaredMeters

	^ CompoundMeasure withAmount: 4 withUnit: (CompoundUnit withUnitsAndPowers: {self meter. 2})! !

!MeasureTest methodsFor: 'distance units' stamp: 'EtchegoyenLajePulver 5/20/2013 21:55'!
hectometer
	
	^ DistanceUnit withUnit: 'hectometer' withConversionFactor: 100! !

!MeasureTest methodsFor: 'time units' stamp: 'EtchegoyenLajePulver 5/20/2013 23:37'!
hour
	
	^ TimeUnit withUnit: 'hour' withConversionFactor: 3600! !

!MeasureTest methodsFor: 'temperature units' stamp: 'EtchegoyenLajePulver 5/23/2013 20:11'!
kelvin
	^ TemperatureUnit baseUnit 
	"^ TemperatureUnit withUnit: 'kelvin' withConversionFactor: 1 withConversionOffset: 273.15"! !

!MeasureTest methodsFor: 'distance units' stamp: 'EtchegoyenLajePulver 5/20/2013 21:55'!
kilometer
	
	^ DistanceUnit withUnit: 'kilometer' withConversionFactor: 1000! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'EtchegoyenLajePulver 5/23/2013 18:56'!
meter
	^ DistanceUnit baseUnit
"	^ DistanceUnit withUnit: 'meter' withConversionFactor: 1 "! !

!MeasureTest methodsFor: 'distance units' stamp: 'EtchegoyenLajePulver 5/20/2013 21:54'!
millimeter
	
	^ DistanceUnit withUnit: 'milimeter' withConversionFactor: (1/1000)! !

!MeasureTest methodsFor: 'distance measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
minusOneMeter 
	
	^SimpleMeasure withAmount: -1 withUnit: self meter! !

!MeasureTest methodsFor: 'time units' stamp: 'EtchegoyenLajePulver 5/20/2013 21:25'!
minute
	
	^ TimeUnit withUnit: 'minute' withConversionFactor: 60 ! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneCelsius
	
	^ SimpleMeasure withAmount: 1 withUnit: self celsius ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneCentimeter
	
	^SimpleMeasure withAmount: 1 withUnit: self centimeter! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneDay
	
	^ SimpleMeasure withAmount: 1 withUnit: self day! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneHour
	
	^ SimpleMeasure withAmount: 1 withUnit: self hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneHundredCentimeters
	
	^ SimpleMeasure withAmount: 100 withUnit: self centimeter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 01:25'!
oneHundredTwentyOneMetersPerSecond

	^ CompoundMeasure withAmount: 121 withUnit: (CompoundUnit withUnitsAndPowers: {self meter. 1. self second. -1})! !

!MeasureTest methodsFor: 'distance measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneMeter
	
	^ SimpleMeasure withAmount: 1 withUnit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 01:18'!
oneMeterPerSecond

	^ CompoundMeasure withAmount: 1 withUnit: (CompoundUnit withUnitsAndPowers: {self meter. 1. self second. -1})! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneMinute
	
	^ SimpleMeasure withAmount: 1 withUnit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
oneSecond

	^ SimpleMeasure withAmount: 1 withUnit: self second! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/22/2013 23:47'!
oneSquaredMeter

	^CompoundMeasure withAmount: 1 withUnit: (CompoundUnit withUnitsAndPowers: {self meter . 2})! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 00:59'!
oneSquaredSecond

	^ CompoundMeasure withAmount: 1 withUnit: (CompoundUnit withUnitsAndPowers: {self second. 2})! !

!MeasureTest methodsFor: 'time units' stamp: 'EtchegoyenLajePulver 5/23/2013 18:56'!
second
	^ TimeUnit baseUnit 
"	^ TimeUnit withUnit: 'second' withConversionFactor: 1 "! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
sixtyMinutes
	
	^ SimpleMeasure withAmount: 60 withUnit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
sixtyOneSeconds
	
	^SimpleMeasure withAmount: 61 withUnit: self second! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
sixtySeconds
	
	^ SimpleMeasure withAmount: 60 withUnit: self second! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'EtchegoyenLajePulver 5/20/2013 21:53'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'EtchegoyenLajePulver 5/21/2013 01:26'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'EtchegoyenLajePulver 5/23/2013 15:15'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self twoMeters / self oneSecond) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
thirtyTwoFahrenheits
	
	^ SimpleMeasure withAmount: 32 withUnit: self fahrenheit ! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
twentyFourHours
	
	^ SimpleMeasure withAmount: 24 withUnit: self hour! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
twoCelsius
	
	^ SimpleMeasure withAmount: 2 withUnit: self celsius! !

!MeasureTest methodsFor: 'distance measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
twoHundredCentimeters
	
	^ SimpleMeasure withAmount: 200 withUnit: self centimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
twoMeters
	
	^ SimpleMeasure withAmount: 2 withUnit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 01:16'!
twoMetersBySecond

	^ CompoundMeasure withAmount: 2 withUnit: (CompoundUnit withUnitsAndPowers: {self meter. 1. self second. -1})! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 01:20'!
twoMetersPerSquaredSecond

	^ CompoundMeasure withAmount: 2 withUnit: (CompoundUnit withUnitsAndPowers: {self meter. 1. self second. -2})! !

!MeasureTest methodsFor: 'compound measures' stamp: 'EtchegoyenLajePulver 5/23/2013 01:06'!
twoMetersTimesSecond

	^ CompoundMeasure withAmount: 2 withUnit: (CompoundUnit withUnitsAndPowers: {self meter. 1. self second. 1})! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
twoSeconds
	
	^SimpleMeasure withAmount: 2 withUnit: self second! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
zeroCelsius
	
	^ SimpleMeasure withAmount: 0 withUnit: self celsius! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
zeroKelvin
	
	^SimpleMeasure withAmount: 0 withUnit: self kelvin! !

!MeasureTest methodsFor: 'distance measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
zeroMeters

	^ SimpleMeasure withAmount: 0 withUnit: self meter! !

!MeasureTest methodsFor: 'time measures' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
zeroSeconds
	
	^ SimpleMeasure withAmount: 0 withUnit: self second! !

Error subclass: #CompoundUnitDoesntHaveBaseUnitError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Error subclass: #UnitTypeMismatchConversionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Object subclass: #Measure
	uses: TComparable
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Measure class
	uses: TComparable classTrait
	instanceVariableNames: ''!

Measure subclass: #CompoundMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 15:21'!
* aMeasure
	|newAmount newUnit|
	newAmount := aMeasure amount * amount.
	newUnit := unit * aMeasure unit.
	
	(unit isCanceled) ifTrue:
		[ ^ newAmount ]
	ifFalse:
		[^ CompoundMeasure withAmount: newAmount withUnit: newUnit]! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 01:24'!
+ aCompoundMeasure
	|newAmount|
	newAmount := amount + aCompoundMeasure amount .
	^ CompoundMeasure withAmount: newAmount withUnit: unit! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:08'!
- aCompoundMeasure
	|newAmount|
	newAmount := amount - aCompoundMeasure amount .
	^ CompoundMeasure withAmount: newAmount withUnit: unit! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:14'!
/ aMeasure
	|newAmount newUnit|
	newAmount := amount / aMeasure amount.
	newUnit := unit / aMeasure unit.
	^ CompoundMeasure withAmount: newAmount withUnit: newUnit! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/22/2013 21:45'!
= aCompoundMeasure
	^(amount = aCompoundMeasure amount) and: [unit = aCompoundMeasure unit]! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 23:21'!
convertTo: aCompoundUnit

	^ self shouldBeImplemented ! !

!CompoundMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 23:08'!
hash
	^ amount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:16'!
withAmount: aSmallInteger withUnit: aDistanceUnit 
	|aMeasure|
	aMeasure := self new.
      aMeasure initializeWithAmount: aSmallInteger withUnit: aDistanceUnit.
	^ aMeasure
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:07'!
* anObject
	^ self subclassResponsibility ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:09'!
+ aMeasure
	^self subclassResponsibility ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:10'!
- aMeasure
	^ self subclassResponsibility 
		
	
	
	
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:07'!
/ anObject
	^ self subclassResponsibility ! !

!Measure methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/26/2013 00:10'!
< aMeasure
	^ self amount < (aMeasure convertTo: self unit) amount.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 22:45'!
amount
	^amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:10'!
convertTo: aMeasureUnit
	^ self subclassResponsibility ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:10'!
createWithSameUnitAndAmount:  anAmount

	^ self class withAmount: anAmount withUnit: self unit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:17'!
initializeWithAmount: aSmallInteger withUnit: aDistanceUnit
	amount := aSmallInteger. 
	unit := aDistanceUnit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 23:13'!
isNothing
	^ (self convertTo: unit class baseUnit) amount = 0! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:04'!
negated

	^ self  * (-1).
	
	
	
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 23:25'!
printString
^ self amount asString , ' ', (self unit printString) , (self amount < 2 ifTrue: [''] ifFalse: ['s'])! !

!Measure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:21'!
unit
	^ unit ! !

Measure subclass: #SimpleMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
* anObject
	
	self class = anObject class
	ifTrue: [ 	
			|aMeasure|
			aMeasure := CompoundMeasure withAmount: amount withUnit: (CompoundUnit withUnitsAndPowers: {self unit. 1}).
			^ aMeasure * anObject.
	]
	ifFalse: [ ^ SimpleMeasure withAmount: (amount * anObject) withUnit: unit ]! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:17'!
+ aSimpleMeasure
	^self createWithSameUnitAndAmount: (self amount + (aSimpleMeasure convertTo: self unit) amount).! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:17'!
- aSimpleMeasure

	^ self + aSimpleMeasure negated
		
	
	
	
	
	! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 19:58'!
/ anObject
	self class = anObject class
	ifTrue: [ 	
			|aMeasure|
			aMeasure := CompoundMeasure withAmount: (1/anObject amount) withUnit: (CompoundUnit withUnitsAndPowers: {anObject unit. -1}).
			^ aMeasure * self.
	]
	ifFalse:
	[^self createWithSameUnitAndAmount: (self amount / anObject)]
	
	
	! !

!SimpleMeasure methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/25/2013 23:20'!
= aSimpleMeasure

	^ (self isNothing and: [ aSimpleMeasure isNothing ]) or: [
		(aSimpleMeasure class = self class) 
		and: [ 
			(aSimpleMeasure unit class = unit class) 
		    	and: [ ((self convertTo: unit class baseUnit ) amount = 
			       (aSimpleMeasure convertTo: aSimpleMeasure unit class baseUnit ) amount )
		  		]
	       	]
		]! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:18'!
convertTo: aMeasureUnit
	|newAmount|
	
	(self unit isKindOf: aMeasureUnit class) ifFalse: [UnitTypeMismatchConversionError signal].
	 
	newAmount := (((amount - unit unitConversionOffset ) *(unit unitConversionFactor)) / aMeasureUnit unitConversionFactor) + aMeasureUnit unitConversionOffset .

	^ SimpleMeasure withAmount:  newAmount withUnit: aMeasureUnit 

! !

!SimpleMeasure methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/26/2013 00:16'!
hash

	^ (self convertTo: unit class baseUnit) amount 
	
	
					 ! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 13:21'!
to: aMeasure
	^ MeasureInterval createFrom: self to: aMeasure! !

!SimpleMeasure methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 13:22'!
to: aMeasure by: aMeasureIncrement
	^ MeasureInterval createFrom: self to: aMeasure by: aMeasureIncrement ! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'interval unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 13:20'!
createFrom: aMeasure to: anotherMeasure
	^ self new initializeFrom: aMeasure to: anotherMeasure! !

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 13:21'!
createFrom: aMeasure to: anotherMeasure by: aMeasureIncrement
	^ self new initializeFrom: aMeasure to: anotherMeasure by: aMeasureIncrement ! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
do: aBlock
	interval do: [:aNumber | aBlock value: (SimpleMeasure withAmount: aNumber withUnit: unit)]! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
first
	^ SimpleMeasure withAmount: interval first withUnit: unit ! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
increment
	^ SimpleMeasure withAmount: interval increment withUnit: unit! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:19'!
initializeFrom: aMeasure to: anotherMeasure
	self initializeFrom: aMeasure to: anotherMeasure  by: (SimpleMeasure withAmount: 1 withUnit: aMeasure unit)! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 13:19'!
initializeFrom: aMeasure to: anotherMeasure by: aMeasureIncrement 
	|toNumber byNumber|
	unit := aMeasure unit.
	toNumber := (anotherMeasure convertTo: aMeasure unit) amount .
	byNumber := (aMeasureIncrement convertTo: aMeasure unit) amount .
	interval := Interval from: aMeasure amount to:  toNumber by: byNumber ! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
last
	^ SimpleMeasure withAmount: interval last withUnit: unit ! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 13:19'!
size
	^ interval size ! !

Object subclass: #MeasureUnit
	instanceVariableNames: 'unitName unitConversionFactor unitConversionOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

MeasureUnit subclass: #CompoundUnit
	instanceVariableNames: 'units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:39'!
baseUnit 
	^ CompoundUnitDoesntHaveBaseUnitError signal! !

!CompoundUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 00:56'!
withDictionaryOfUnitsAndPowers: aDictionary
	^self new initializeWithDictionaryOfUnitsAndPowers: aDictionary! !

!CompoundUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/22/2013 20:41'!
withUnitsAndPowers: anArrayOfPairs
	^self new initializeWithUnitsAndPowers: anArrayOfPairs ! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:23'!
* aSimpleUnit
	|newUnits|
	newUnits := units.
	newUnits at: aSimpleUnit ifPresent: [ :value | newUnits at: aSimpleUnit put: value+1 ] ifAbsent: [ newUnits at: aSimpleUnit put: 1 ].
	^ CompoundUnit withDictionaryOfUnitsAndPowers: newUnits
! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:23'!
/ aSimpleUnit
	|newUnits|
	newUnits := units.
	newUnits at: aSimpleUnit ifPresent: [ :value | newUnits at: aSimpleUnit put: value-1 ] ifAbsent: [ newUnits at: aSimpleUnit put: -1 ].
	^ CompoundUnit withDictionaryOfUnitsAndPowers: newUnits
! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/22/2013 21:30'!
= aCompoundUnit
	^ units = aCompoundUnit units
! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 00:58'!
initializeWithDictionaryOfUnitsAndPowers: aDictionary
	units:= aDictionary ! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/22/2013 20:43'!
initializeWithUnitsAndPowers: anArrayOfPairs 
	units:= Dictionary newFromPairs: anArrayOfPairs ! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 15:32'!
isCanceled
	| allZero |
	allZero := true.
	units valuesDo: [ :aValue | allZero := (allZero and: [aValue = 0])  ].
	^ allZero! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/22/2013 21:30'!
units
	^ units
! !

MeasureUnit subclass: #DistanceUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 18:52'!
baseUnit
	^ DistanceUnit withUnit: 'meter' withConversionFactor: 1 ! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 18:52'!
baseUnit
	self subclassResponsibility 
	! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/20/2013 21:31'!
withUnit: aByteString withConversionFactor: anAmount
	^ self withUnit: aByteString withConversionFactor: anAmount withConversionOffset: 0
! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/20/2013 21:30'!
withUnit: aByteString withConversionFactor: anAmount withConversionOffset: aConversionOffset
	|aDistanceUnit|
	aDistanceUnit := self new.
     aDistanceUnit initializeWithUnit: aByteString withConversionFactor: anAmount withConversionOffset: aConversionOffset .
	^ aDistanceUnit
! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/25/2013 20:10'!
* aNumber

	^ SimpleMeasure withAmount: aNumber withUnit: self! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/26/2013 00:33'!
= aMeasureUnit

	^ (aMeasureUnit class = self class) and: [ 
		self unitName = aMeasureUnit unitName and:[ self unitConversionFactor = aMeasureUnit unitConversionFactor 
			and: [ unitConversionOffset =  aMeasureUnit unitConversionOffset ]]]! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 12:37'!
adaptToInteger: anInteger andSend: aMessage

	^ self perform: aMessage with: anInteger! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 00:15'!
hash 
	^ unitName hash
	! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/20/2013 21:08'!
initializeWithUnit: aByteString withConversionFactor: aConversionFactor withConversionOffset: aConversionOffset
	unitConversionOffset:= aConversionOffset.
	unitConversionFactor:= aConversionFactor.
	unitName:= aByteString.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/8/2013 21:00'!
printString
    ^ self unitName asString ! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/8/2013 20:29'!
unitConversionFactor
	^ unitConversionFactor! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/20/2013 21:07'!
unitConversionOffset
	^ unitConversionOffset! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/8/2013 20:29'!
unitName 
	^ unitName
	! !

MeasureUnit subclass: #TemperatureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 20:28'!
baseUnit
	^ TemperatureUnit withUnit: 'kelvin' withConversionFactor: 1 ! !

MeasureUnit subclass: #TimeUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeUnit class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/23/2013 18:52'!
baseUnit
	^ TimeUnit withUnit: 'second' withConversionFactor: 1 ! !
